## kf6-kio 6.17.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

set(KF_VERSION "6.17.0") # handled by release scripts
set(KF_DEP_VERSION "6.17.0") # handled by release scripts

project(KIO VERSION ${KF_VERSION})

include(FeatureSummary)
find_package(ECM 6.17.0 NO_MODULE)
set_package_properties(ECM PROPERTIES TYPE REQUIRED DESCRIPTION "Extra CMake Modules." URL "https://commits.kde.org/extra-cmake-modules")
feature_summary(WHAT REQUIRED_PACKAGES_NOT_FOUND FATAL_ON_MISSING_REQUIRED_PACKAGES)

set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake )

include(KDEInstallDirs)
include(KDEFrameworkCompilerSettings NO_POLICY_SCOPE)
include(KDECMakeSettings)
include(KDEGitCommitHooks)
include(KDEPackageAppTemplates)

include(ECMGenerateExportHeader)
include(ECMMarkAsTest)
include(ECMSetupVersion)
include(ECMGenerateHeaders)
include(ECMMarkNonGuiExecutable)
include(ECMQtDeclareLoggingCategory)
include(ECMSourceVersionControl)
include(ECMDeprecationSettings)
include(ECMGenerateQDoc)

ecm_setup_version(
  PROJECT
  VARIABLE_PREFIX KIO
  VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/src/kio_version.h"
  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KF6KIOConfigVersion.cmake"
  SOVERSION 6)

set(EXCLUDE_DEPRECATED_BEFORE_AND_AT 0 CACHE STRING "Control the range of deprecated API excluded from the build [default=0].")

option(KIOCORE_ONLY "Only compile KIOCore, not KIOWidgets or anything that depends on it. This will disable support for cookies and passwordhandling (prompting and storing)." OFF)

# Enable state assertion by default on Jenkins and from-git builds.
# This option should eventually be dropped and always be enabled.
set(ASSERT_WORKER_STATES_DEFAULT OFF)
if(DEFINED ENV{JENKINS_SERVER_COOKIE} OR ECM_SOURCE_UNDER_VERSION_CONTROL)
    set(ASSERT_WORKER_STATES_DEFAULT ON)
endif()
option(KIO_ASSERT_WORKER_STATES
    "Used to control whether worker state assertions are enabled. When not enabled only warnings are generated."
    ${ASSERT_WORKER_STATES_DEFAULT})

option(BUILD_DESIGNERPLUGIN "Build plugin for Qt Designer" ON)
add_feature_info(DESIGNERPLUGIN ${BUILD_DESIGNERPLUGIN} "Build plugin for Qt Designer")

option(USE_FTPD_WSGIDAV_UNITTEST "Use ftpd Ruby Gem (for ftptest) and wsgidav Python module (for webdavtest) in unittests. Note that this is a temporary option that will be removed when distros add those packages in their repos." OFF)

find_package(KF6Archive ${KF_DEP_VERSION} REQUIRED)
find_package(KF6Config ${KF_DEP_VERSION} REQUIRED)
find_package(KF6CoreAddons ${KF_DEP_VERSION} REQUIRED)
find_package(KF6I18n ${KF_DEP_VERSION} REQUIRED)
find_package(KF6Service ${KF_DEP_VERSION} REQUIRED)
find_package(KF6DocTools ${KF_DEP_VERSION})
find_package(KF6Solid ${KF_DEP_VERSION} REQUIRED) # for kio_trash
if (NOT ANDROID)
    find_package(KF6Crash ${KF_DEP_VERSION} REQUIRED)
endif()

if (NOT KIOCORE_ONLY)
find_package(KF6Bookmarks ${KF_DEP_VERSION} REQUIRED)
find_package(KF6ColorScheme ${KF_DEP_VERSION} REQUIRED)
find_package(KF6Completion ${KF_DEP_VERSION} REQUIRED)
find_package(KF6GuiAddons ${KF_DEP_VERSION} REQUIRED)
find_package(KF6IconThemes ${KF_DEP_VERSION} REQUIRED)
find_package(KF6ItemViews ${KF_DEP_VERSION} REQUIRED)
find_package(KF6JobWidgets ${KF_DEP_VERSION} REQUIRED)
find_package(KF6WidgetsAddons ${KF_DEP_VERSION} REQUIRED)
find_package(KF6WindowSystem ${KF_DEP_VERSION} REQUIRED)

find_package(KF6KDED ${KF_DEP_VERSION})
set_package_properties(KF6KDED PROPERTIES DESCRIPTION "Daemon providing session services"
                       TYPE RUNTIME
                       PURPOSE "KDED is used at runtime for proxy management and cookie storage"
                      )

find_package(SwitcherooControl)
set_package_properties(SwitcherooControl PROPERTIES
    TYPE RUNTIME
    PURPOSE "Hybrid GPU support"
)

endif()

if (UNIX AND NOT ANDROID)
    find_package(KF6Auth ${KF_DEP_VERSION} REQUIRED)
endif()

# tell what is missing without doctools
set_package_properties(KF6DocTools PROPERTIES DESCRIPTION "Provides tools to generate documentation in various format from DocBook files"
                       TYPE OPTIONAL
                       PURPOSE "Required to build help KIO worker and documentation"
                      )

set(REQUIRED_QT_VERSION 6.7.0)
find_package(Qt6 ${REQUIRED_QT_VERSION} CONFIG REQUIRED Widgets Network Concurrent Xml Test)

if (Qt6Gui_VERSION VERSION_GREATER_EQUAL "6.10.0")
    find_package(Qt6GuiPrivate ${REQUIRED_QT_VERSION} REQUIRED NO_MODULE)
endif()

# shall we use DBus?
# enabled per default on Linux & BSD systems
set(USE_DBUS_DEFAULT OFF)
if(UNIX AND NOT APPLE AND NOT ANDROID AND NOT HAIKU)
    set(USE_DBUS_DEFAULT ON)
endif()
option(USE_DBUS "Build components using DBus" ${USE_DBUS_DEFAULT})
set(DBUS_LIB)
if(USE_DBUS)
    find_package(KF6DBusAddons ${KF_DEP_VERSION} REQUIRED)
    find_package(Qt6 ${REQUIRED_QT_VERSION} CONFIG REQUIRED DBus)
    set(HAVE_QTDBUS ${Qt6DBus_FOUND})
    add_definitions(-DWITH_QTDBUS)
    set(DBUS_LIB Qt6::DBus)
endif()

if (NOT APPLE AND NOT WIN32 AND NOT ANDROID AND NOT HAIKU)
    option(WITH_X11 "Build with X11 integration" ON)
    set(HAVE_X11 ${WITH_X11})

    option(WITH_WAYLAND "Build with Wayland integration" ON)
    set(HAVE_WAYLAND ${WITH_WAYLAND})
endif()

find_package(ACL)
set(HAVE_LIBACL ${ACL_FOUND})
set(HAVE_POSIX_ACL ${ACL_FOUND})
set_package_properties(ACL PROPERTIES DESCRIPTION "LibACL"
                       URL "ftp://oss.sgi.com/projects/xfs/cmd_tars"
                       TYPE RECOMMENDED
                       PURPOSE "Support for manipulating access control lists")

# Used by KMountPoint
if (CMAKE_SYSTEM_NAME MATCHES "Linux")
    find_package(LibMount REQUIRED)
    set(HAVE_LIB_MOUNT ${LibMount_FOUND})
endif()

ecm_set_disabled_deprecation_versions(
    QT 6.9.0
    KF 6.14.0
)

add_definitions(-DTRANSLATION_DOMAIN=\"kio6\")
ki18n_install(po)

if (KF6DocTools_FOUND)
    kdoctools_install(po)
endif()

if (KF6DocTools_FOUND)
     add_subdirectory(docs)
endif()

if(BUILD_TESTING)
    add_definitions(-DBUILD_TESTING)
endif()

include(CheckLibraryExists)
add_subdirectory(src)

if(BUILD_TESTING)
    add_subdirectory(autotests)
    if (NOT KIOCORE_ONLY)
        add_subdirectory(tests)
    endif()
endif()

add_subdirectory(templates)

# create a Config.cmake and a ConfigVersion.cmake file and install them
set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/KF6KIO")

include(CMakePackageConfigHelpers)

configure_package_config_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/KF6KIOConfig.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/KF6KIOConfig.cmake"
  PATH_VARS KDE_INSTALL_DBUSINTERFACEDIR
  INSTALL_DESTINATION  ${CMAKECONFIG_INSTALL_DIR}
)

install(FILES
  "${CMAKE_CURRENT_BINARY_DIR}/KF6KIOConfig.cmake"
  "${CMAKE_CURRENT_BINARY_DIR}/KF6KIOConfigVersion.cmake"
  DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
  COMPONENT Devel
)

install(EXPORT KF6KIOTargets DESTINATION "${CMAKECONFIG_INSTALL_DIR}" FILE KF6KIOTargets.cmake NAMESPACE KF6:: )

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/src/kio_version.h
        DESTINATION ${KDE_INSTALL_INCLUDEDIR_KF}/KIO COMPONENT Devel)

include(ECMFeatureSummary)
ecm_feature_summary(WHAT ALL   FATAL_ON_MISSING_REQUIRED_PACKAGES)

kde_configure_git_pre_commit_hook(CHECKS CLANG_FORMAT)

=== src/CMakeLists.txt ===
add_subdirectory(core)

# KIOCore-only executables
if (NOT ANDROID)
    add_subdirectory(kioworkers)
    add_subdirectory(schemehandlers)
endif()

if (HAVE_QTDBUS)
    add_subdirectory(kiod)
    add_subdirectory(kssld)
endif()
add_subdirectory(kioworker)

if (NOT KIOCORE_ONLY)
    add_subdirectory(gui)
    add_subdirectory(widgets)

    if (HAVE_QTDBUS)
        add_subdirectory(kpasswdserver)
        add_subdirectory(kioexec)
    endif()

    if (NOT ANDROID)
        add_subdirectory(filewidgets)
        add_subdirectory(urifilters)
    endif()

    if(BUILD_DESIGNERPLUGIN AND HAVE_QTDBUS)
        add_subdirectory(designer)
    endif()
endif()

ecm_qt_install_logging_categories(
    EXPORT KIO
    FILE kio.categories
    DESTINATION ${KDE_INSTALL_LOGGINGCATEGORIESDIR}
)

=== autotests/http/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 Nicolas Fella <nicolas.fella@gmx.de>
# SPDX-License-Identifier: BSD-3-Clause

add_executable(sslerrortest sslerrortest.cpp)
target_link_libraries(sslerrortest PRIVATE Qt::Network KF6::KIOWidgets)

add_executable(gettest gettest.cpp)
target_link_libraries(gettest PRIVATE Qt::Network Qt::Test KF6::KIOCore)

add_executable(headtest headtest.cpp)
target_link_libraries(headtest PRIVATE Qt::Network Qt::Test KF6::KIOCore)

add_executable(redirecttest redirecttest.cpp)
target_link_libraries(redirecttest PRIVATE Qt::Network Qt::Test KF6::KIOCore)

add_executable(puttest puttest.cpp)
target_link_libraries(puttest PRIVATE Qt::Network Qt::Test KF6::KIOCore)

add_executable(posttest posttest.cpp)
target_link_libraries(posttest PRIVATE Qt::Network Qt::Test KF6::KIOCore)

add_executable(stattest stattest.cpp)
target_link_libraries(stattest PRIVATE Qt::Network Qt::Test KF6::KIOCore)

add_executable(cookiestest cookiestest.cpp)
target_link_libraries(cookiestest PRIVATE Qt::Network Qt::Test KF6::KIOCore)

add_executable(authtest authtest.cpp)
target_link_libraries(authtest PRIVATE Qt::Network Qt::Test KF6::KIOCore)

add_executable(propagateheaderstest propagateheaderstest.cpp)
target_link_libraries(propagateheaderstest PRIVATE Qt::Network Qt::Test KF6::KIOCore)

add_executable(useragenttest useragenttest.cpp)
target_link_libraries(useragenttest PRIVATE Qt::Network Qt::Test KF6::KIOCore)

add_executable(errortest errortest.cpp)
target_link_libraries(errortest PRIVATE Qt::Network Qt::Test KF6::KIOCore)

add_executable(accepttest accepttest.cpp)
target_link_libraries(accepttest PRIVATE Qt::Network Qt::Test KF6::KIOCore)

add_executable(referrertest referrertest.cpp)
target_link_libraries(referrertest PRIVATE Qt::Network Qt::Test KF6::KIOCore)

add_executable(customheadertest customheadertest.cpp)
target_link_libraries(customheadertest PRIVATE Qt::Network Qt::Test KF6::KIOCore)

add_executable(responsecodetest responsecodetest.cpp)
target_link_libraries(responsecodetest PRIVATE Qt::Network Qt::Test KF6::KIOCore)

=== docs/kioworker6/CMakeLists.txt ===
add_subdirectory(data)
add_subdirectory(file)
add_subdirectory(ftp)
add_subdirectory(help)
add_subdirectory(http)
add_subdirectory(webdav)

=== src/core/CMakeLists.txt ===
include (ConfigureChecks.cmake)

configure_file(config-kiocore.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-kiocore.h )

configure_file(config-kmountpoint.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-kmountpoint.h)

configure_file(../kioworkers/file/config-stat-unix.h.in ${CMAKE_CURRENT_BINARY_DIR}/config-stat-unix.h)

add_library(KF6KIOCore)
add_library(KF6::KIOCore ALIAS KF6KIOCore)

set_target_properties(KF6KIOCore PROPERTIES
    VERSION     ${KIO_VERSION}
    SOVERSION   ${KIO_SOVERSION}
    EXPORT_NAME KIOCore
)

target_sources(KF6KIOCore PRIVATE
  connectionbackend.cpp
  connection.cpp
  connectionserver.cpp
  krecentdocument.cpp
  krecentdirs.cpp
  kfileitemlistproperties.cpp
  directorysizejob.cpp
  chmodjob.cpp
  usernotificationhandler.cpp
  ksambasharedata.cpp
  ksambashare.cpp
  knfsshare.cpp
  kfileitem.cpp
  davjob.cpp
  deletejob.cpp
  copyjob.cpp
  filejob.cpp
  mkdirjob.cpp
  mkpathjob.cpp
  kremoteencoding.cpp
  slavebase.cpp
  workerbase.cpp
  dataworker.cpp
  dataprotocol.cpp
  desktopexecparser.cpp
  emptytrashjob.cpp
  authinfo.cpp
  job_error.cpp
  job.cpp
  filecopyjob.cpp
  listjob.cpp
  mimetypejob.cpp
  mimetypefinderjob.cpp
  restorejob.cpp
  simplejob.cpp
  specialjob.cpp
  statjob.cpp
  namefinderjob.cpp
  storedtransferjob.cpp
  transferjob.cpp
  filesystemfreespacejob.cpp
  scheduler.cpp
  kprotocolmanager.cpp
  hostinfo.cpp
  kurlauthorized.cpp
  kacl.cpp
  udsentry.cpp
  global.cpp
  metadata.cpp
  kprotocolinfo.cpp
  kprotocolinfofactory.cpp
  jobtracker.cpp
  jobuidelegateextension.cpp
  jobuidelegatefactory.cpp
  askuseractioninterface.cpp
  kmountpoint.cpp
  kcoredirlister.cpp
  faviconscache.cpp
  untrustedprogramhandlerinterface.cpp
  kioglobal_p.cpp
  batchrenamejob.cpp
  worker.cpp
  workerinterface.cpp
  workerconfig.cpp
  workerfactory.cpp
  workerthread.cpp
  kfilefilter.cpp
  koverlayiconplugin.cpp
  openwith.cpp
  ksslcertificatemanager.cpp
  ksslerroruidata.cpp
)

set(KIOCore_HEADERS_dbus)
if (HAVE_QTDBUS)
  target_sources(KF6KIOCore PRIVATE
    kpasswdserverloop.cpp
    kpasswdserverclient.cpp
    kdirnotify.cpp
    forwardingworkerbase.cpp
  )
  set(KIOCore_HEADERS_dbus KDirNotify)
endif()

ecm_qt_declare_logging_category(KF6KIOCore
    HEADER kiocoredebug.h
    IDENTIFIER KIO_CORE
    CATEGORY_NAME kf.kio.core
    OLD_CATEGORY_NAMES kf5.kio.core
    DESCRIPTION "KIOCore (KIO)"
    EXPORT KIO
)

ecm_qt_export_logging_category(
    IDENTIFIER KIO_COPYJOB_DEBUG
    CATEGORY_NAME kf.kio.core.copyjob
    OLD_CATEGORY_NAMES kf5.kio.core.copyjob
    DEFAULT_SEVERITY Warning
    DESCRIPTION "KIO::CopyJob (KIO)"
    EXPORT KIO
)

ecm_qt_export_logging_category(
    IDENTIFIER KIO_CORE_DIRLISTER
    CATEGORY_NAME kf.kio.core.dirlister
    OLD_CATEGORY_NAMES kf5.kio.core.dirlister
    DEFAULT_SEVERITY Warning
    DESCRIPTION "KCoreDirLister (KIO)"
    EXPORT KIO
)

ecm_qt_export_logging_category(
    IDENTIFIER KIO_CORE_SAMBASHARE
    CATEGORY_NAME kf.kio.core.sambashare
    OLD_CATEGORY_NAMES kf5.kio.core.sambashare
    DEFAULT_SEVERITY Warning
    DESCRIPTION "sambashare (KIO)"
    EXPORT KIO
)

ecm_qt_declare_logging_category(KF6KIOCore
    HEADER kiocoreconnectiondebug.h
    IDENTIFIER KIO_CORE_CONNECTION
    CATEGORY_NAME kf.kio.core.connection
    DEFAULT_SEVERITY Warning
    DESCRIPTION "Connection (KIO)"
    EXPORT KIO
)

if (UNIX)
   target_sources(KF6KIOCore PRIVATE
      kioglobal_p_unix.cpp
   )
endif()
if (WIN32)
   target_sources(KF6KIOCore PRIVATE
      kioglobal_p_win.cpp
   )
endif()

set(kiocore_dbus_SRCS)
if (HAVE_QTDBUS)
    qt_add_dbus_interface(kiocore_dbus_SRCS org.kde.KIOFuse.VFS.xml kiofuse_interface)

    set_source_files_properties(org.kde.KPasswdServer.xml
            PROPERTIES INCLUDE authinfo.h
    )
    qt_add_dbus_interface(kiocore_dbus_SRCS org.kde.KPasswdServer.xml kpasswdserver_interface)

    qt_add_dbus_interface(kiocore_dbus_SRCS org.freedesktop.PowerManagement.Inhibit.xml inhibit_interface)

    qt_add_dbus_interface(kiocore_dbus_SRCS org.freedesktop.portal.Inhibit.xml portal_inhibit_interface)
    qt_add_dbus_interface(kiocore_dbus_SRCS org.freedesktop.portal.Request.xml portal_request_interface)
endif()

target_sources(KF6KIOCore PRIVATE
    ${kiocore_dbus_SRCS}
)

ecm_generate_export_header(KF6KIOCore
    BASE_NAME KIOCore
    GROUP_BASE_NAME KF
    VERSION ${KF_VERSION}
    USE_VERSION_HEADER
    VERSION_BASE_NAME KIO
    DEPRECATED_BASE_VERSION 0
    DEPRECATION_VERSIONS 5.101 6.3 6.4 6.6 6.9 6.11 6.15
    EXCLUDE_DEPRECATED_BEFORE_AND_AT ${EXCLUDE_DEPRECATED_BEFORE_AND_AT}
)

target_include_directories(KF6KIOCore PUBLIC
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/..>" # kio_version.h
)

target_include_directories(KF6KIOCore INTERFACE
    "$<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR_KF}/KIOCore>"
    "$<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR_KF}/KIO>"
)

target_link_libraries(KF6KIOCore
PUBLIC
 KF6::CoreAddons   # KJob
 Qt6::Network
PRIVATE
 Qt6::Xml # davjob.cpp uses QDom
 Qt6::Concurrent
 KF6::ConfigCore
 KF6::I18n
 KF6::Service
)

if (NOT ANDROID)
    target_link_libraries(KF6KIOCore PRIVATE KF6::Crash)
endif()

if (HAVE_QTDBUS)
    target_link_libraries(KF6KIOCore PUBLIC ${DBUS_LIB})
endif()

if (TARGET KF6::AuthCore)
  target_link_libraries(KF6KIOCore PRIVATE KF6::AuthCore)   #SlaveBase uses KAuth::Action
endif()

if(ACL_FOUND)
  target_link_libraries(KF6KIOCore PRIVATE ${ACL_LIBS})
endif()

if(HAVE_LIB_MOUNT)
  target_link_libraries(KF6KIOCore PRIVATE LibMount::LibMount)
endif()

# this should be done by cmake, see bug 371721
if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    add_custom_command(
        OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/moc_predefs.h
        COMMAND "${CMAKE_CXX_COMPILER}" "${CMAKE_CXX_COMPILER_ARG1}" "-dM" "-E" "-c" "${CMAKE_ROOT}/Modules/CMakeCXXCompilerABI.cpp" > ${CMAKE_CURRENT_BINARY_DIR}/moc_predefs.h
    )
    set_property(TARGET KF6KIOCore APPEND PROPERTY AUTOMOC_MOC_OPTIONS --include ${CMAKE_CURRENT_BINARY_DIR}/moc_predefs.h)
    set_property(TARGET KF6KIOCore APPEND PROPERTY AUTOGEN_TARGET_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/moc_predefs.h)
endif()

# Headers prefixed with KIO/
ecm_generate_headers(KIOCore_CamelCase_HEADERS
  HEADER_NAMES
  DirectorySizeJob
  Job #     ### should forward to job_base.h, not job.h...
  JobTracker
  Global
  ChmodJob
  DeleteJob
  CopyJob
  EmptyTrashJob
  FileJob
  MkdirJob
  MkpathJob
  MetaData
  UDSEntry
  JobUiDelegateExtension
  JobUiDelegateFactory
  AskUserActionInterface
  FileCopyJob
  ListJob
  MimetypeJob
  MimeTypeFinderJob
  RestoreJob
  SimpleJob
  SpecialJob
  StatJob
  NameFinderJob
  StoredTransferJob
  TransferJob
  AuthInfo
  DavJob
  DesktopExecParser
  FileSystemFreeSpaceJob
  BatchRenameJob
  WorkerBase
  WorkerFactory
  ForwardingWorkerBase
  UntrustedProgramHandlerInterface
  OpenWith

  PREFIX KIO
  REQUIRED_HEADERS KIO_namespaced_HEADERS
)

# Create local forwarding header for kio/job_base.h
set(REGULAR_HEADER_NAME ${CMAKE_CURRENT_BINARY_DIR}/kio/job_base.h)
if (NOT EXISTS ${REGULAR_HEADER_NAME})
   file(WRITE ${REGULAR_HEADER_NAME} "#include \"${CMAKE_CURRENT_SOURCE_DIR}/job_base.h\"\n")
endif()


install(TARGETS KF6KIOCore EXPORT KF6KIOTargets ${KF_INSTALL_TARGETS_DEFAULT_ARGS})

list(APPEND KIO_namespaced_HEADERS
  ioworker_defaults.h
  job_base.h
)

install(FILES
  ${KIO_namespaced_HEADERS}
  DESTINATION ${KDE_INSTALL_INCLUDEDIR_KF}/KIOCore/kio COMPONENT Devel
)

# Headers not prefixed with KIO/
ecm_generate_headers(KIOCore_HEADERS
  HEADER_NAMES
  KACL
  KUrlAuthorized
  KCoreDirLister
  KRemoteEncoding
  KFileItem
  KFileItemListProperties
  KMountPoint
  KSambaShare
  KSambaShareData
  KPasswdServerClient
  KProtocolInfo
  KProtocolManager
  KRecentDocument
  KRecentDirs
  KSslErrorUiData
  KFileFilter
  KOverlayIconPlugin
  ${KIOCore_HEADERS_dbus}

  REQUIRED_HEADERS KIOCore_HEADERS
)

ecm_generate_qdoc(KF6KIOCore kiocore.qdocconf)

install(FILES ${KIOCore_CamelCase_HEADERS} DESTINATION ${KDE_INSTALL_INCLUDEDIR_KF}/KIOCore/KIO COMPONENT Devel)

install(FILES
  ${KIOCore_HEADERS}
  ${CMAKE_CURRENT_BINARY_DIR}/kiocore_export.h
  DESTINATION ${KDE_INSTALL_INCLUDEDIR_KF}/KIOCore COMPONENT Devel)

=== docs/kioworker6/http/CMakeLists.txt ===
########### install files ###############
kdoctools_create_handbook(index.docbook INSTALL_DESTINATION ${KDE_INSTALL_DOCBUNDLEDIR}/en SUBDIR kioworker6/http)

=== src/kioworkers/http/CMakeLists.txt ===
kcoreaddons_add_plugin(kio_http
    INSTALL_NAMESPACE kf6/kio
)

target_sources(kio_http PRIVATE
    http.cpp
)

ecm_qt_declare_logging_category(kio_http
    HEADER debug.h
    IDENTIFIER KIOHTTP_LOG
    CATEGORY_NAME kf.kio.workers.http
    DEFAULT_SEVERITY Info
    DESCRIPTION "kio_http (KIO)"
    EXPORT KIO
)

target_link_libraries(kio_http KF6::KIOCore KF6::I18n KF6::ConfigCore Qt6::Network Qt6::Xml)

=== debian/changelog ===
kf6-kio (6.17.0-0ubuntu2) questing; urgency=medium

  * No-change rebuild for Qt 6.9.2 private ABI.

 -- Rik Mills <rikmills@kde.org>  Tue, 16 Sep 2025 21:36:06 +0100

kf6-kio (6.17.0-0ubuntu1) questing; urgency=medium

  * New upstream release (6.17.0)
  * Update symbols from build logs.

 -- Rik Mills <rikmills@kde.org>  Fri, 08 Aug 2025 18:15:54 +0100

=== debian/control ===
Source: kf6-kio
Section: libs
Priority: optional
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
           Patrick Franz <deltaone@debian.org>,
Build-Depends: cmake (>= 3.16~),
               debhelper-compat (= 13),
               dh-sequence-kf6,
               dh-sequence-pkgkde-symbolshelper,
               dh-sequence-sodeps,
               doxygen,
               extra-cmake-modules (>= 6.17.0~),
               gettext,
               kded6-dev (>= 6.17.0~),
               libacl1-dev,
               libkf6archive-dev (>= 6.17.0~),
               libkf6auth-dev (>= 6.17.0~),
               libkf6bookmarks-dev (>= 6.17.0~),
               libkf6colorscheme-dev (>= 6.17.0~),
               libkf6completion-dev (>= 6.17.0~),
               libkf6config-dev (>= 6.17.0~),
               libkf6configwidgets-dev (>= 6.17.0~),
               libkf6coreaddons-dev (>= 6.17.0~),
               libkf6crash-dev (>= 6.17.0~),
               libkf6dbusaddons-dev (>= 6.17.0~),
               libkf6doctools-dev (>= 6.17.0~),
               libkf6guiaddons-dev (>= 6.17.0~),
               libkf6i18n-dev (>= 6.17.0~),
               libkf6iconthemes-dev (>= 6.17.0~),
               libkf6itemviews-dev (>= 6.17.0~),
               libkf6jobwidgets-dev (>= 6.17.0~),
               libkf6service-dev (>= 6.17.0~),
               libkf6solid-dev (>= 6.17.0~),
               libkf6wallet-dev (>= 6.17.0~),
               libkf6widgetsaddons-dev (>= 6.17.0~),
               libkf6windowsystem-dev (>= 6.17.0~),
               libmount-dev [linux-any],
               libxml2-dev,
               libxslt1-dev,
               qt6-5compat-dev (>= 6.6.0~),
               qt6-base-dev (>= 6.6.0~),
               qt6-tools-dev (>= 6.5.0~),
Standards-Version: 4.7.0
Homepage: https://invent.kde.org/frameworks/kio
Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kf6-kio
Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kf6-kio
Rules-Requires-Root: no

Package: kio6
Architecture: any
Depends: kded6,
         kwallet6,
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: switcheroo-control [amd64 i386],
Suggests: systemsettings,
Description: resource and network access abstraction
 KDE Input/Output framework provides a single API for
 operating on files, whether local or on a remote server.
 Additionally, KIO Slaves provide support for individual
 protocols. Some particularly useful ones are http, ftp,
 sftp, smb, nfs, ssh (fish), man, tar and zip.

Package: libkf6kio-dev
Section: libdevel
Architecture: any
Depends: libkf6bookmarks-dev (>= 6.17.0~),
         libkf6completion-dev (>= 6.17.0~),
         libkf6config-dev (>= 6.17.0~),
         libkf6coreaddons-dev (>= 6.17.0~),
         libkf6itemviews-dev (>= 6.17.0~),
         libkf6jobwidgets-dev (>= 6.17.0~),
         libkf6service-dev (>= 6.17.0~),
         libkf6solid-dev (>= 6.17.0~),
         libkf6widgetsaddons-dev (>= 6.17.0~),
         libkf6windowsystem-dev (>= 6.17.0~),
         qt6-base-dev (>= 6.5.0+dfsg~),
         ${misc:Depends},
         ${shlibs:Depends},
         ${so:Depends},
Recommends: libkf6kio-doc (= ${source:Version}),
Description: resource and network access abstraction (development files)
 KDE Input/Output framework provides a single API for
 operating on files, whether local or on a remote server.
 Additionally, KIO Slaves provide support for individual
 protocols. Some particularly useful ones are http, ftp,
 sftp, smb, nfs, ssh (fish), man, tar and zip.
 .
 This package contains the development files for kio.

Package: libkf6kio-doc
Architecture: all
Section: doc
Multi-Arch: foreign
Depends: ${misc:Depends},
Description: resource and network access abstraction (documentation)
 KDE Input/Output framework provides a single API for
 operating on files, whether local or on a remote server.
 Additionally, KIO Slaves provide support for individual
 protocols. Some particularly useful ones are http, ftp,
 sftp, smb, nfs, ssh (fish), man, tar and zip.
 .
 This package contains the QCH documentation files.

Package: libkf6kiocore6
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
Multi-Arch: same
Description: resource and network access abstraction (KIO core library)
 KDE Input/Output framework provides a single API for
 operating on files, whether local or on a remote server.
 Additionally, KIO Slaves provide support for individual
 protocols. Some particularly useful ones are http, ftp,
 sftp, smb, nfs, ssh (fish), man, tar and zip.
 .
 This library contains the core classes.

Package: libkf6kiofilewidgets6
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
Multi-Arch: same
Description: resource and network access abstraction (KIO file widgets library)
 KDE Input/Output framework provides a single API for
 operating on files, whether local or on a remote server.
 Additionally, KIO Slaves provide support for individual
 protocols. Some particularly useful ones are http, ftp,
 sftp, smb, nfs, ssh (fish), man, tar and zip.
 .
 This library contains some file dialog widgets.

Package: libkf6kiogui6
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
Multi-Arch: same
Description: resource and network access abstraction (KIO gui library)
 KDE Input/Output framework provides a single API for
 operating on files, whether local or on a remote server.
 Additionally, KIO Slaves provide support for individual
 protocols. Some particularly useful ones are http, ftp,
 sftp, smb, nfs, ssh (fish), man, tar and zip.
 .
 This library contains gui related jobs.

Package: libkf6kiowidgets6
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
Multi-Arch: same
Description: resource and network access abstraction (KIO widgets library)
 KDE Input/Output framework provides a single API for
 operating on files, whether local or on a remote server.
 Additionally, KIO Slaves provide support for individual
 protocols. Some particularly useful ones are http, ftp,
 sftp, smb, nfs, ssh (fish), man, tar and zip.
 .
 This library contains some UI widgets.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=+lto

include /usr/share/dpkg/architecture.mk

ifneq (linux,$(DEB_HOST_ARCH_OS))
        EXTRA_CMAKE_ARGS += -DWITH_WAYLAND=OFF
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_QCH=ON -DBUILD_TESTING=OFF -DBUILD_PYTHON_BINDINGS=OFF $(EXTRA_CMAKE_ARGS)

override_dh_shlibdeps:
	dh_shlibdeps $(patsubst %,-p%,$(filter lib%,$(shell dh_listpackages))) -- -xkio6
	dh_shlibdeps --remaining-packages

override_dh_auto_test:
	# Disable dh_auto_test at build time
	:
